RandomUnimodularMat is slow with many iters
Status: In Progress Start date: 25 Nov 2019

Priority: Low Due date:  

Assignee:  % Done: 10%

Category: Improving Estimated time: 0.00 hour

Target version: CoCoALib-1.0 Spent time: 0.75 hour

Description

RandomUnimodularMat becomes too slow when number of iters is high.

Try a divide-and-conquer approach.

Related issues:

Related to CoCoALib - Feature #955: RandomUnimodularMat - random unimodular m... Closed 27 Oct 2016

History

#1 - 25 Nov 2019 13:46 - John Abbott

- Related to Feature #955: RandomUnimodularMat - random unimodular matrix (of integers) added

#2 - 25 Nov 2019 13:48 - John Abbott

RandomUnimodularMat(QQ,4,1000000) takes too long.  It is faster to do product([RandomUnimodularMat(QQ,4,10000) | j in 1..100])

Divide-and-conquer makes sense; not sure when it should switch over to simple linear approach.

#3 - 25 Nov 2019 20:33 - John Abbott

- Status changed from New to In Progress

- % Done changed from 0 to 10

First impl is quite disappointing; the overhead/cost of matrix mult is embarrassingly high.

Should do recursion based on the internal vector< vector<BigInt> > structure then convert to matrix only at the end.

Not tonight, Josephine!

#4 - 09 Jan 2020 12:19 - John Abbott

- Target version changed from CoCoALib-0.99700 to CoCoALib-1.0
